/*****************************************************************
 * Programm...: cgitest                                          *
 * Projekt....: cgi_tester                                       *
 * Zweck......: Setzt die Umgebung und fhrt CGI aus             *
 * Autor......: Rudolf Weber W-4 Nonnenbroich und Weber Gbr      *
 * Copyright..: 1995                                             *
 * Rechtliches: Darf nur mit Quellen weiterverkauft werden,      *
 *              Fr Konkurenten: pro Benutzung 5 DM              * 
 *              d.h. fr jedes Cgi, das mit diesem Tool getestet *
 *              worden ist                                       *
 *****************************************************************/
#include<unistd.h>
#include<iostream.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<sys/types.h>
#include<sys/wait.h>
#include<sys/errno.h>
#include<getopt.h>

char puffer[1024];
char *env[100];
char **arg;

main(int argc,char **argv)
{
  FILE *fp;
  char **p = env;
  int inhaltlang;
  int c;
  int v=0;  
  char *cgidump;
  char *binary;

  while((c=getopt(argc,argv,"v"))!=-1)
  {
    switch(c)
    {
    case 'v': v=1; break; // verbose
    default: cerr << "Unbekannte Option !\n";
    }
  }
  if(argc-optind < 2)
  {
    cerr << "Aufruf: " << argv[0] << " <Umgebung> <CGI>\n";
    exit(1);
  }
  cgidump = argv[optind++];
  binary = argv[optind++];
  arg = argv+optind;

  fp=fopen(cgidump,"r");
  if(fp == NULL)
  {
    cerr << "Datei " << argv[optind] << " nicht gefunden\n";
    exit(1);
  }
  while(fgets(puffer,1024,fp)!=NULL && puffer[0]!='*')
  {
    char *cp = puffer;
    while(*cp != '\0' && *cp != '\n') *cp++;
    *cp = '\0';
    // cout << puffer << endl;
    *(p++) = strdup(puffer);
  }
  *p=NULL;
  if(v)
  {
    cerr << "Starte: " << binary;
    for(char **a=arg;*a!=NULL;a++)
    {
      cerr << " " << *a;
    }
    
    cerr << "\nUmgebung:\n";
    for(p=env;*p!=NULL;p++)
    {
      cerr << *p << endl;
    }
  }
  if(puffer[0]!='*')
  {
    cerr << "Datei " << cgidump << " entspricht nicht den Konventionen !\n";
    exit(1);
  }
  inhaltlang = atoi(puffer+1);
  if(inhaltlang > 0)
  {
    int p[2]; /* p[0]: lesen p[1] schreiben !!!! */
    pid_t pid;
    char *buffer = (char *)malloc(inhaltlang+2);
    fread(buffer,sizeof(char),inhaltlang,fp);
    if(v) { cout << "puffer=" << buffer <<"\n";}
    pipe(p);
    if((pid = fork()))
    {
      int l;
      int status;
      /* Vater */
      close(p[0]);
      l = write(p[1],buffer,inhaltlang);
      if(l!=inhaltlang)
      {
	cerr << "write: Nicht alles geschrieben (" << strerror(errno) << ")"
             << endl;
      }
      close(p[1]);
      if(v) {cerr << "Warte auf Beendigung von " << pid << " ... " << endl;}
      waitpid(pid,&status,0);
      if(v) 
      {
	cerr << "Der Cgi-proze " << pid << " hat mit Status " << status
	     << " terminiert \n";
      }
    }
    else
    {
      close(p[1]);
      dup2(p[0],0);
      close(p[0]);
      execve(argv[2],arg,env);
    }
  }
  else
  {
    execve(argv[2],arg,env);
  }
}

