/*****************************************************************
 * Programm...: merk.cgi.cc                                      *
 * Projekt....: cgi_tester                                       *
 * Zweck......: Merkt die Umgebung des Cgi                       * 
 * Autor......: Rudolf Weber                                     *
 * Copyright..: 1996  W-4 Nonnenbroich und Weber Gbr             *
 *              1997  Rudolf Weber Informatikberatung Ravensburg *
 * Rechtliches: Darf nur mit Quellen weiterverkauft werden,      *
 *              Fr Kommerzielle Nutzer: pro Benutzung 20 DM     * 
 *              d.h. fr jedes Cgi, das mit diesem Tool getestet *
 *              worden ist                                       *
 *****************************************************************/
#include<stdio.h>
#include<iostream.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/wait.h>
#include<pwd.h>
#include<fcntl.h>

const char REQUEST_METHOD[]="REQUEST_METHOD";
const char CONTENT_LENGTH[]="CONTENT_LENGTH";

void html_kopf(char *titel);
void html_ende();
char *gethomedir(int uid);   // ergebnis mit malloc allokiert - igitt :-(

inline char hex(char z)
{
    if('0' <= z && z <= '9') return z-'0';
    if('a' <= z && z <= 'f') return z-'a'+10;
    if('A' <= z && z <= 'F') return z-'A'+10;
    return 0;
}

main(int argc,char **argv,char **env)
{
   FILE *fp;
   char filename[100];
   char *reqmeth = NULL;
   int inhaltlang = -1;
   int euid = geteuid();
   char *home = gethomedir(euid);
   char *buffer;

   html_kopf("Cgi-Dump");  
   if(euid != 65534 && home )  sprintf(filename,"%s/cgidump",home);
   else                        sprintf(filename,"/tmp/cgidump%d",euid);

   cout << "<H2>User-Information</H2>Ich bin effektiv Nutzer " << euid 
        << " und pinsele daher in " << filename << "<p>\n";
   fp=fopen(filename,"w");
   if(fp == NULL)
   {
     cout << "Datei "<< filename <<" kann leider nicht geschreiben werden!\n";
     html_ende();
     exit(1);
 
   }
   if(argv[1] != NULL)
   {
     cout << "<H2>Die Argumente</H2>\n";
     for(char **arg=argv+1;*arg!=NULL;arg++)
     {
       cout << *arg << endl;
     }
   }
   printf("<H2>Die Environment-Variablen</H2>\n");
   for(char **p=env;*p!=NULL;p++)
   {
     cout << *p << " <p>\n";
     fprintf(fp,"%s\n",*p);
     if(strncmp(*p,REQUEST_METHOD,sizeof(REQUEST_METHOD)-1)==0)
     {
         reqmeth = (*p)+sizeof(REQUEST_METHOD);
     }
     else if(strncmp(*p,CONTENT_LENGTH,sizeof(CONTENT_LENGTH)-1)==0)
     {
       inhaltlang = atoi((*p)+sizeof(CONTENT_LENGTH));
     }
   }
   cout << "Die Requestmethode ist " 
        << (reqmeth ? reqmeth : "nicht vorhanden ")
        << " und die Inhaltlaenge ist " << inhaltlang << "\n";
  
   fprintf(fp,"*%d\n",inhaltlang);
   fflush(fp);
   if(reqmeth != NULL && strcmp(reqmeth,"POST")==0 && inhaltlang > 0)
   {
       buffer = (char *)malloc(inhaltlang+2);
       if(read(0,buffer,inhaltlang)!=inhaltlang)
       {
	 cout << "hurps: Weniger gelesen ....\n";
         fprintf(fp,"error\n");
	 exit(1);
       }
       buffer[inhaltlang]='\0';
       cout << "Post = " << buffer << '\n';
       fwrite(buffer,sizeof(char),inhaltlang,fp);
   }
   fclose(fp);
   html_ende();
}

void html_kopf(char *titel)
{
  cout << "Content-type: text/html\n\n";
  cout << "<HTML>\n<TITLE>" << titel << "</TITLE>\n</HEAD>\n<BODY>\n";
  cout << "<H1>" << titel << "</H1>\n";
}

void html_ende()
{
  cout << "</BODY>\n</HTML>\n";
}

char *gethomedir(int uid)
{
   char *ret;
   struct passwd *passptr = getpwuid(uid);

   if(passptr == NULL) return NULL;
   ret=passptr->pw_dir;
 
   return ret;
}




