/***********************************************************************
 * Modul....: cgivar.cc                                                *
 * Zweck....: Analyse von CGI-Variablen                                *
 * Author...: Rudolf Weber Informatikberatung Ravensburg               *
 * Copyright: 1997                                                     *
 * Bedingungen wie GNU_LIBRARY_LICENCE,                                *
 * aber bei kommerziellen Verwendern Anteil an Verkaufserls erwartet  *
 ***********************************************************************/
#include<iostream.h>
#include<stdio.h>
#include<unistd.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<stdlib.h>
#include<string.h>
#include<pwd.h>
//#include"etext.h"
#include"cgiausg.h"
#include"cgivar.h"

int aufspalt(Varmap *erg,char *puffer,int inhaltlang)
{
  char *l = puffer;
  char *s = puffer;
  char *m = l;
  char *lname;
  char *lwert;
  
  if(inhaltlang == 0) return -1;
  while(l < puffer+inhaltlang)
  {
    switch(*l)
    {
    case '=':
      *s++='\0';
      lname = m;
      m=s;l++;
      break;
    case '&':
      *s++='\0';
      lwert = m;
      m=s;l++;
      erg->insert(lname,lwert);
      break;
    case '+':
      *s++ = ' ';
      l++;
      break;
    case '%':
      *s++ = (hex(l[1]) << 4) + hex(l[2]);
      l+=3;
      break;    
    default: 
      *s++ = *l++;	
    }
  }
  *s='\0';
  lwert=m;
  erg->insert(lname,lwert);
  return 0;
}

void probeausgabe(Varmap *tab)
{
  const char *name;
  const char *inhalt;

  for(Varmapiter it(tab);it()!=NULL;it.next())
  {
    it.inhalt(name,inhalt);
    cout << name << " = " << inhalt << "<p>"<<endl;
  }
}

const char REQUEST_METHOD[]="REQUEST_METHOD";
const char CONTENT_LENGTH[]="CONTENT_LENGTH";
const char QUERY_STRING[]="QUERY_STRING";

static char *gethomedir(int uid)
{
   char *ret;
   struct passwd *passptr = getpwuid(uid);

   if(passptr == NULL) return NULL;
   ret=passptr->pw_dir;
   free(passptr->pw_name);
   free(passptr->pw_passwd);
   free(passptr->pw_shell);
   free(passptr);
 
   return ret;
}

int getcgienv(Varmap *erg,char **env,int options)
{
  char filename[100];
  int post=0;
  char *querystring=NULL;
  int querystringlen=0;
  char *puffer;
  int inhaltlang;
  FILE *fp=NULL;

  if(options&GCV_DUMP)
  {
    int euid = geteuid();
    char *home = gethomedir(euid);
    html_kopf("Cgi-Dump");  
    if(euid != 65534 && home )  sprintf(filename,"%s/cgidump",home);
    else                        sprintf(filename,"/tmp/cgidump%d",euid);
    
    cout << "<H2>User-Information</H2>Ich bin effektiv Nutzer " << euid 
	 << " und pinsele daher in " << filename << "<p>\n";
    fp=fopen(filename,"w");
    if(fp == NULL)
    {
      cout << "Datei "<< filename <<" kann leider nicht geschrieben werden!\n";
      html_ende();
      exit(1);
    }
  }
  if(options&GCV_DEBUGL2) cout << "<H2>Die Environmentvariablen</H2>" << endl;
  for(char **e = env; *e != NULL; e++)
  {
    if(options&GCV_DEBUGL2) cout << *e << "<p>\n";
    if(options&GCV_DUMP) fprintf(fp,"%s\n",*e);
    if(strncmp(*e,REQUEST_METHOD,sizeof(REQUEST_METHOD)-1)==0)
    {
       if(strncasecmp((*e)+sizeof(REQUEST_METHOD),"POST",4)==0)
       {
	 post=1;
       }
       else if(strncasecmp((*e)+sizeof(REQUEST_METHOD),"GET",3)==0)
       {
	 post = 0;
       }
       else
       {	 
         cout << "Fehler auf HTML_Seite: Zugriffsmethode: " 
              << (*e)+sizeof(REQUEST_METHOD) 
	      << "<p>\n";
         html_ende();
         exit(1);   
       } 
    }
    else if(strncmp(*e,CONTENT_LENGTH,sizeof(CONTENT_LENGTH)-1)==0)
    {
	inhaltlang = atoi((*e)+sizeof(CONTENT_LENGTH));
    }
    else if(strncmp(*e,QUERY_STRING,sizeof(QUERY_STRING)-1)==0)
    {
        querystring=(*e)+sizeof(QUERY_STRING);
	querystringlen=strlen(querystring);
    }
    else
    {
      if(options&GCV_ENVVARS)
      {
	char *p = index(*e,'=');
	char *name,*inhalt;
	if(p==NULL)
	{
	  cgi_error("ENV_Variable %s ohne '='",*e);
	}
	*p='\0';
	name=*e;
	inhalt=p+1;
	erg->insert(name,inhalt);
      }
    }
  }

  if(options&GCV_DUMP)
  {
    fprintf(fp,"*%d\n",inhaltlang);
    fflush(fp);
  }
  if(post)
  {
    if(options&GCV_DEBUGL1) cout << "Lnge des Inhalts:" << inhaltlang << "\n";

    puffer = (char *)malloc(inhaltlang+1);
    if(read(0,puffer,inhaltlang)!=inhaltlang)
    {
      cgi_error("Das kann eigendlich nicht vorkommen, da ich nicht alles lesen kann, ist es aber ...");
    }
    if(options&GCV_DUMP)
    {
      fwrite(puffer,sizeof(char),inhaltlang,fp);
    }
    puffer[inhaltlang]='\0';

    if(options&GCV_DEBUGL2) cout << "<PRE>" << puffer << "</PRE>\n";
    aufspalt(erg,puffer,inhaltlang);


  }
  if(querystring)
  {
    aufspalt(erg,querystring,querystringlen);
  }  
  if(options&GCV_DUMP)
  {
    fclose(fp);
  }
}
