#include<iostream.h>
#include<unistd.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<stdlib.h>
#include<string.h>
#include"etext.h"
#include"cgivarlist.h"

const char REQUEST_METHOD[]="REQUEST_METHOD";
const char CONTENT_LENGTH[]="CONTENT_LENGTH";
const char QUERY_STRING[]="QUERY_STRING";

void Cgivarlist::init(char **env)
{
  int post=0;
  char *querystring=NULL;
  int querystringlen=0;

  for(char **e = env; *e != NULL; e++)
  {
    //cout << *e << "<p>\n";
    if(strncmp(*e,REQUEST_METHOD,sizeof(REQUEST_METHOD)-1)==0)
    {
       if(strncasecmp((*e)+sizeof(REQUEST_METHOD),"POST",4)==0)
       {
	 post=1;
       }
       else if(strncasecmp((*e)+sizeof(REQUEST_METHOD),"GET",3)==0)
       {
	 post = 0;
       }
       else
       {	 
         cout << "Fehler im Script: Zugriffsmethode: " 
              << (*e)+sizeof(REQUEST_METHOD) 
	      << "<p>\n";
         html_ende();
         exit(1);   
       } 
    }
    else if(strncmp(*e,CONTENT_LENGTH,sizeof(CONTENT_LENGTH)-1)==0)
    {
	inhaltlang = atoi((*e)+sizeof(CONTENT_LENGTH));
    }
    else if(strncmp(*e,QUERY_STRING,sizeof(QUERY_STRING)-1)==0)
    {
        querystring=(*e)+sizeof(QUERY_STRING);
	querystringlen=0;
    }
  }
  if(post)
  {
#ifdef DEBUG
    cout << "Lnge des Inhalts:" << inhaltlang << "\n";
#endif
    puffer = (char *)malloc(inhaltlang+1);
    if(read(0,puffer,inhaltlang)!=inhaltlang)
    {
      error("Das kann eigendlich nicht vorkommen, da ich nicht alles lesen kann, ist es aber ...");
    }
    puffer[inhaltlang]='\0';
    
    aufspalt(puffer,inhaltlang);
#ifdef DEBUG
    cout << "<PRE>" << puffer << "</PRE>\n";
    ausgabe();
#endif 
  }
  if(querystring)
  {
    aufspalt(querystring,querystringlen);
  }  
}

int Cgivarlist::aufspalt(char *puffer,int inhaltlang)
{
    
    list_el **akt=&wurzel;
    char *l = puffer;
    char *s = puffer;
    char *m = l;
        
    while(l < puffer+inhaltlang)
    {
      char *lname;
      char *lwert;
      switch(*l)
      {
      case '=':
	*s++='\0';
	lname = m;
	m=s;l++;
	break;
      case '&':
	*s++='\0';
	lwert = m;
	m=s;l++;
	break;
      case '+':
	*s++ = ' ';
	l++;
	break;
      case '%':
	*s++ = (hex(l[1]) << 4) + hex(l[2]);
	l+=3;
	break;    
      default: 
	*s++ = *l++;	
      }
    }
    *akt = new list_el(lname,lwert);
    akt = &((*akt)->next);
    *s='\0';
    
}

void Cgivarlist::ausgabe()
{
   for(list_el *list=wurzel;list != NULL;list=list->next)
   {
       cout << list->name << " = " << list->wert << "<p>\n";
       
   }    
}

char *Cgivarlist::operator[](char *name)
{
  int r=0;
  list_el *list;
  if(*name == '$') name++;
  
  for(list = wurzel;list != NULL && (r=strcmp(name,list->name))!=0;
      list->next);

  if(list->name != NULL && r == 0 ) return list->wert;
  else return "";  
}

void Cgivarlist::clear(char *name)
{
  list_el **akt=&wurzel;
  list_el *weg;
  int r;
  if(*name=='$') name++;
  while(*akt != NULL && r=(strcmp(name,(*akt)->name)!=0))
  {
    akt=&((*akt)->next);
  }
  if(*akt!= NULL && r)
  {
     weg=*akt;
     *akt = (*akt)->next;
     delete weg;
  }
}


void Cgivarlist::clearall()
{
  list_el *last;
  list_el *akt=wurzel;
  while(akt!=NULL)
  {
    last=akt;
    akt=akt->next;
    free(last);
  }
  
}


